'Sprinkler on touch V4 Rev3 Standard Micromite - 2 screens. Last edited 9-10-23


' Added background 2 day watering of plants using SETTICK command
' Added heartbeat on screen.
' Added time & RTC

'TO DO... ADD CANCEL FUNCTION POSSIBLY USING SETTICK AND/OR INTERRUPT..
' Add AM / PM
 
OPTION EXPLICIT
OPTION DEFAULT NONE
option autorun on

SetPin 16,DOUT  'Sol 1
SetPin 17,DOUT  'Sol 2
SetPin 18,DOUT  'Sol 3
setpin 24,DOUT  'Sol 4

CONST SECS = 1000   ' 1000Ms = 1 second
CONST MINS = 60000  ' INSERT 60 INSTEAD OF 60000 FOR TESTING
CONST HAMDELAY = 2000 'ANTI HAMMER DELAY IS 2 SECONDS
CONST FRONTSOL = 16   'Pin 16 drives Front Sol
CONST REARSOL = 17    'Pin 17 drives Rear Sol
CONST HILLSOL = 18    'Pin 18 drives Hill Sol
CONST PLANTSOL = 24    'Pin 24 drives Plants Sol
DIM INTEGER HOMESCREEN, GOBACK, PLANTSMIN, FRONTMIN, REARMIN, HILLMIN, MANUALMIN ' defines Variables.

DIM INTEGER Minset1, Minset2, Minset3 ' MINSET adjusted from 1 to 30.
DIM INTEGER CountDown ' Count down time.
DIM INTEGER CANCELINT ' TO MONITOR IF I NEED TO CANCEL SCREEN OR NOT
DIM INTEGER FLASHER ' FOR TESTING SETTICK FUNCTION ONLY
VAR RESTORE
 
FRONTMIN = 15    '
REARMIN = 15      '
HILLMIN=15        'RESETS VARIABLES TO DEFAULT 
MANUALMIN=30      '
PLANTSMIN=10      ' 
HOMESCREEN=0      '
GOBACK=0          '


SETTICK 172800000,PLANTS2DAYS,2  ' ( 2 DAYS IS 172800000 )

SETTICK 12 * 100, DisplayTime, 4 ' interrupt to display time


START:

DO
IF HOMESCREEN < 1 THEN SCREEN1
IF TOUCH(X) <> -1 THEN TAPPED
GOBACK = 0  ' GOBACK =0 when in homescreen and GOBACK = 1 when in MANUAL screen
LOOP

SUB DISPLAYTIME
RTC GETTIME
FUNCTION MyTime$(hours, minutes)
LOCAL h
h = hours
IF hours > 12 THEN h = h - 12
MyTime$ = STR$(h) + ":" + STR$(minutes)
IF hours <= 12 THEN
MyTime$ = MyTime$ + "AM"
ELSE
MyTime$ = MyTime$ + "PM"
ENDIF
END FUNCTION
TEXT 150,45,STR$(MYTIME),CM,1,2,rgb(WHITE),RGB(BLACK)
END SUB



SUB PLANTS2DAYS
PIN(PLANTSOL)=1     'Sol 3 on 
TEXT 160,100," 2 DAY PLANT WATER ",CM,1,2,rgb(BLACK),RGB(BLUE)
Countdown=Plantsmin
    Gosub Count
    PIN(PLANTSOL)=0     ' Finished watering
    TEXT 160,100,"   PLANTS DONE     ",CM,1,2,rgb(WHITE),RGB(BLUE)
  end sub


  SUB TAPPED
    TEXT 160,100,"                   ",CM,1,2,rgb(BLACK),RGB(BLACK)  'CLEARS MESSAGE LINE INSTEAD OF CLS
    const tx=TOUCH(X)
    const ty=TOUCH(Y)
    if tx > 260 and tx < 320 and ty > 1 and ty < 43 then MANUAL
    IF tx > 15 AND tx < 135 AND ty > 165 AND ty < 225 THEN AUTO
    IF tx > 170 AND tx < 285 AND ty > 165 AND ty < 225 THEN PLANTS
    ENDIF
    ENDIF
    ENDIF
    ENDIF
  END SUB

  SUB SCREEN1
    CLS
    TEXT 1,5,"Ver 4 Rev2",LM,1,1,RGB(red),RGB(black)
    rbox 25,170,120,50,10,rgb(red),rgb(green) 'AUTO BOX
    rbox 180,170,120,50,10,rgb(red),rgb(green)' PLANTS BOX
    RBOX 250,5,60,30,10,RGB(YELLOW),RGB(BLUE)' MANUAL BOX
    TEXT 257,20,"MAN",LM,1,2,RGB(WHITE),RGB(BLUE)
    TEXT 55,195,"AUTO",LM,1,2,RGB(BLACK),RGB(GREEN)
    TEXT 193,195,"PLANTS",LM,1,2,RGB(BLACK),RGB(GREEN)
    HOMESCREEN = HOMESCREEN + 1 'HOMESCREEN HAS BEEN LOADED
  END SUB


  SUB MANUAL  'DRAWS 2ND SCREEN

    CLS
        
    CIRCLE 205, 20, 12, 2, 1, RGB(red),RGB(black)' draws circle for back button
        BOX 154,1,50,50,1,RGB(black),RGB(black)' rubs out half of circle    
        line 162,8,204,8,2,rgb(red)' top line of return
        line 175,31,204,31,2,rgb(red)' bottom line of return
        line 159,9,172,3,1,rgb(red)' arrow head top
        line 159,9,172,14,1,rgb(red)' arrow head bottom
        line 158,9,171,3,1,rgb(red)' arrow head top
        line 158,9,171,14,1,rgb(red)' arrow head bottom
    '
    
    
    RBOX 5,75,60,40,10,RGB(WHITE),RGB(RED)' Manual. Top left "-" button
    RBOX 70,70,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. Top middle button
    RBOX 135,75,60,40,10,RGB(WHITE),RGB(RED)' Manual. Top right "+" button
    TEXT 27,95,"-",LM,1,3,RGB(WHITE),RGB(RED) 'Manual. Top left "-" text
    TEXT 87,95,STR$(Minset1),LM,1,2,RGB(BLACK),RGB(GREEN)'Manual. Top middle text
    TEXT 167,95,"+",CM,1,3,RGB(WHITE),rgb(red)'Manual. Top right "+"text
    TEXT 260,95,"FRONT",CM,1,2,RGB(WHITE),rgb(BLACK)
    
        
    RBOX 5,135,60,40,10,RGB(WHITE),RGB(RED)' Manual. MID left - button
    RBOX 70,130,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. MID middle button
    RBOX 135,135,60,40,10,RGB(WHITE),RGB(RED)' Manual. MID right button
    TEXT 27,155,"-",LM,1,3,RGB(WHITE),RGB(RED) 'Manual. Mid left "-" text
    TEXT 87,155,STR$(Minset2),LM,1,2,RGB(BLACK),RGB(GREEN) 'Manual. Mid middle text
    TEXT 167,155,"+",CM,1,3,RGB(WHITE),rgb(red) 'Manual. Mid right "+"text
    TEXT 260,155,"REAR",CM,1,2,RGB(WHITE),rgb(BLACK)
    
    RBOX 5,195,60,40,10,RGB(WHITE),RGB(RED)' Manual. BOT left - button
    RBOX 70,190,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. BOT middle button
    RBOX 135,195,60,40,10,RGB(WHITE),RGB(RED)' Manual. BOT right button
    TEXT 27,215,"-",LM,1,3,RGB(WHITE),RGB(RED) 'Manual.BOT left "-" text
    TEXT 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(GREEN) 'Manual. BOT middle text
    TEXT 167,215,"+",CM,1,3,RGB(WHITE),rgb(red) 'Manual. BOT right "+"text
    TEXT 260,215,"HILL",CM,1,2,RGB(WHITE),rgb(BLACK)
    
    RBOX 70,190,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. BOT middle button
    TEXT 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(GREEN) 'Manual. BOT middle text    

        
    HOMESCREEN = 0  ' HOMESCREEN IS NOT ACTIVE
    DO
    IF TOUCH(X) <> -1 THEN SCREEN2TOUCH ' TESTS TOUCH ON MANUAL SCREEN
    IF GOBACK > 0 THEN END sub
    LOOP
   
    
  END SUB

  SUB SCREEN2TOUCH
  
    TEXT 160,50,"                   ",CM,1,2,rgb(BLACK),RGB(BLACK)  'CLEARS MESSAGE LINE INSTEAD OF CLS
    
    const tx=TOUCH(X)
    const ty=TOUCH(Y)
   
     
    if tx > 1 and tx < 52 and ty > 76 and ty < 115 then SUBTIME1       'TOP LEFT "-" BUTTON
    IF tx > 1 AND tx < 52 AND ty > 135 AND ty < 175 THEN SUBTIME2        ' MID LEFT "-" BUTTON
    IF tx > 1 AND tx < 52 AND ty > 195 AND ty < 240 THEN SUBTIME3        'BOTTOM LEFT "-" BUTTON
    if tx > 126 and tx < 187 and ty > 76 and ty < 115 then ADDTIME1        'TOP RIGHT "-" BUTTON
    IF tx > 126 AND tx < 187 AND ty > 135 AND ty < 175 THEN ADDTIME2        ' MID RIGHT "-" BUTTON
    IF tx > 126 AND tx < 187 AND ty > 195 AND ty < 240 THEN ADDTIME3        'BOTTOM RIGHT "-" BUTTON
    if tx > 57 and tx < 119 and ty > 71 and ty < 122 then FRONT         'TOP MIDDLE "-" BUTTON
    IF tx > 57 AND tx < 119 AND ty > 135 AND ty < 180 THEN REAR        ' MID MIDDLE "-" BUTTON
    IF tx > 57 AND tx < 119 AND ty > 190 AND ty < 240 THEN HILL        'BOTTOM MIDDLE "-" BUTTON
  
    if tx > 130 and tx < 220 and ty > 1 and ty < 43 then GOBACK = GOBACK + 1 ' IF BACK PRESSED THEN RELOAD SCREEN1
    ENDIF
    ENDIF
    ENDIF
  END SUB
  
  SUB addTIME1  
    Minset1 = Minset1 + 1
    IF Minset1 => 30 THEN Minset1 = 30 
    Text 87,95,STR$(Minset1),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    Var Save Minset1
    pause 300
    END SUB
    
  SUB SUBTIME1  
    Minset1 = Minset1 - 1
    IF MINSET1 = 0 THEN MINSET1 = 1 + 1
    Text 87,95,"  ",LM,1,2,RGB(BLACK),RGB(GREEN) 'CLEAR TEXT IN BOX
    Text 87,95,STR$(Minset1),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    ENDIF
    Var Save Minset1
    pause 300
    END SUB
    
    SUB addTIME2  
    Minset2 = Minset2 + 1
    IF Minset2 => 30 THEN Minset2 = 30 
    Text 87,155,STR$(Minset2),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    Var Save Minset2
    pause 300
    END SUB
    
  SUB SUBTIME2  
    Minset2 = Minset2 - 1
    IF MINSET2 = 0 THEN MINSET2 = 1 + 1
    Text 87,155,"  ",LM,1,2,RGB(BLACK),RGB(GREEN) 'CLEAR TEXT IN BOX
    Text 87,155,STR$(Minset2),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    ENDIF
    Var Save Minset2
    pause 300
    END SUB
    
    SUB addTIME3  
    Minset3 = Minset3 + 1
    IF Minset3 => 30 THEN Minset3 = 30 
    Text 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    Var Save Minset3
    pause 300
    END SUB
    
  SUB SUBTIME3  
    Minset3 = Minset3 - 1
    IF MINSET3 = 0 THEN MINSET3 = 1 + 1
    Text 87,215,"  ",LM,1,2,RGB(BLACK),RGB(GREEN) 'CLEAR TEXT IN BOX
    Text 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(GREEN) 'MANUAL PAGE LINE 1 TEXT
    ENDIF
    ENDIF
    Var Save Minset3
    pause 300
    END SUB

  SUB AUTO
  
  

    PIN(FRONTSOL)=1     'Turn on 1st sprinkler
    TEXT 160,100,"WATERING FRONT",CM,1,2,rgb(WHITE),RGB(BLUE)
    'TEXT 160,250,STR$(CountDown),CM,1,2,RGB(WHITE),RGB(BLUE)
    Pause FRONTMIN*MINS    'Watering 15min
    pin(REARSOL)=1     'Sol 2 on - anti hammer
    Pause HAMDELAY     'off delay - anti hammer
    PIN(FRONTSOL)=0     ' Sol 1 off
    TEXT 160,100," WATERING BACK ",CM,1,2,rgb(WHITE),RGB(BLUE)
    Pause REARMIN*MINS    ' Watering 15min
    PIN(HILLSOL)=1     'Sol 3 on - Anti Hammer
    Pause HAMDELAY     ' off delay - anti hammer
    PIN(REARSOL)=0     'Sol 2 off
    TEXT 160,100," WATERING HILL ",CM,1,2,rgb(WHITE),RGB(BLUE)
    Pause HILLMIN*MINS    ' Watering 15 min
    Pin(HILLSOL)=0     ' Finished watering
    TEXT 160,100," FINISHED AUTO ",CM,1,2,rgb(WHITE),RGB(BLUE)
    
  END SUB
  
  
  SUB FRONT
    PIN(FRONTSOL)=1     'Turn on 1st sprinkler
    TEXT 160,50,"WATERING FRONT",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,70,60,50,10,RGB(WHITE),RGB(WHITE)' Manual. Top middle button
    TEXT 87,95,STR$(Minset1),LM,1,2,RGB(BLACK),RGB(WHITE)'Manual. Top middle text
    Pause MINSET1*MINS    'Watering SET mins
    PIN(PLANTSOL)=1     'Sol 3 on - Anti Hammer
    Pause HAMDELAY     ' off delay - anti hammer
    PIN(FRONTSOL)=0     'Front Sol off
    Pause HAMDELAY     ' off delay - anti hammer
    PIN(PLANTSOL)=0     ' Finished watering
    TEXT 160,50,"    FRONT DONE     ",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,70,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. Top middle button
    TEXT 87,95,STR$(Minset1),LM,1,2,RGB(BLACK),RGB(GREEN)'Manual. Top middle text
  END SUB

  SUB HILL
    PIN(HILLSOL)=1     'Sol 3 on 
    TEXT 160,50," WATERING HILL ",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,190,60,50,10,RGB(WHITE),RGB(WHITE)' Manual. BOT middle button
    TEXT 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(WHITE) 'Manual. BOT middle text
    Pause MINSET2*MINS    ' Watering SET min
    PIN(HILLSOL)=0     ' Finished watering
    TEXT 160,50,"    HILL DONE     ",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,190,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. BOT middle button
    TEXT 87,215,STR$(Minset3),LM,1,2,RGB(BLACK),RGB(GREEN) 'Manual. BOT middle text
  end sub


  SUB REAR
    PIN(REARSOL)=1     'Turn on 1st sprinkler
    TEXT 160,50,"WATERING REAR",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,130,60,50,10,RGB(WHITE),RGB(WHITE)' Manual. MID middle button
    TEXT 87,155,STR$(Minset2),LM,1,2,RGB(BLACK),RGB(WHITE) 'Manual. Mid middle text
    Pause MINSET3*MINS    'Watering SET min
    PIN(PLANTSOL)=1     'Sol 3 on - Anti Hammer
    Pause HAMDELAY     ' off delay - anti hammer
    PIN(REARSOL)=0     'Rear Sol off
    Pause HAMDELAY     ' off delay - anti hammer
    PIN(PLANTSOL)=0     ' Finished watering
    TEXT 160,50,"    REAR DONE     ",CM,1,2,rgb(WHITE),RGB(BLUE)
    RBOX 70,130,60,50,10,RGB(WHITE),RGB(GREEN)' Manual. MID middle button
    TEXT 87,155,STR$(Minset2),LM,1,2,RGB(BLACK),RGB(GREEN) 'Manual. Mid middle text
  end sub

  SUB PLANTS
    PIN(PLANTSOL)=1     'Sol 3 on 
    TEXT 160,100," WATERING PLANTS ",CM,1,2,rgb(BLACK),RGB(BLUE)
    Countdown=Plantsmin
    Gosub Count
    PIN(PLANTSOL)=0     ' Finished watering
    TEXT 160,100,"   PLANTS DONE     ",CM,1,2,rgb(WHITE),RGB(BLUE)
  end sub
  
Count:
 
  CountLoop:
  TEXT 160,250,STR$(CountDown),CM,1,2,RGB(WHITE),RGB(BLUE)
  pause 1*MINS
  Countdown=Countdown-1
  IF Countdown>0 then goto CountLoop
  endif
  end sub
  
  'Display count, delay 1 min, loop till 0 then return.
  
  
  
  
